#!ruby -Ks
=begin rdoc
= rdremocon.rb
̃t@CŒ`NX

* RDremoconConnector
   RD̃lbgR̒ʐMG~[gAĐԂȂǂ̏𓾂鎖
   oNXB܂ʐMɂălbgdeL[{[h̑҂󂯂˂B

Developers:: ghiaccio@plala.to

:title:RDremocon RDoc
=end

$KCODE = 's'
require "socket"

#lbgR̒ʐMG~[gNX
#
#=== USAGE
#1. N
#     rdremo = RDremoconConnector.new("rd-x6")
#2. ʐMJn(Xbh𐶐AȌ͒ʐMԂɂȂ܂)
#     rdremo.start()
#3. Ȍ̓CxgN邽тɁ`changedœo^\bhĂ΂܂B

class RDremoconConnector

  #ڑɑÂR}h
  #16i1048
  ConnectionCommand = "\x10\x48"

  #^Cgԍ
  attr_reader(:no)

  #^Cg
  attr_reader(:title)

  #(b)
  attr_reader(:time_tortal)
  #Đ̎(b)
  attr_reader(:time_now)
  #`v^[n_̎(b)
  attr_reader(:time_now2)

  #`l
  attr_reader(:channel)

  #lbgL[{[h̏(ON=1 OFF=0)
  attr_reader(:netkeyboard)

  #
  # host zXg
  def initialize(host)

    #zXg|[gԍ폜(11/08/07)
    if host =~ /^([\S\s]+?)\:(\d+?)$/
      @host = $1
    else
      @host = host
    end

    #݂̃^Cg
    @title = ""
    #݂̔ԍ
    @no = 0
    #݂̏
    @status = 0
    #݂̃t@C̑
    @time_tortal = 0
    #݂̃`l
    @channel = 0
    #݂̎
    @time_now = 0
    #`v^[̎
    @time_now2 = 0
    #lbgL[{[h̏(ON=1 OFF=0)
    @netkeyboard = 0
    #ĐǂH(Play=2 Stop=0)
    @movie1 = 0
    #Đ̏
    # [ ]=3 [>]=4 [<]=7 [||]=5 [>>]=6
    @movie2 = 0

    @proc_netkeyboard = nil
    @proc_title = nil
    @proc_time_tortal = nil
    @proc_time_now = nil
    @proc_movie1 = nil
  end

  #Đ̏ꍇ^Ԃ
  def playing?
    return (@movie1 == 2)
  end

  #Ԃ̏ԕԂ
  def time_status
    return format("%s / %s", time_to_s(@time_now), time_to_s(@time_tortal))
  end

  #--
  #------------------------------------------------------- Event
  #++
  #lbgL[{[hԂωꍇɌĂ΂郁\bh̓o^
  def netkeyboard_changed
    @proc_netkeyboard = Proc.new
  end

  #^CgωꍇɌĂ΂郁\bh̓o^
  def title_changed
    @proc_title = Proc.new
  end

  #g[^bωꍇɌĂ΂郁\bho^
  def time_tortal_changed
    @proc_time_tortal = Proc.new
  end

  #ݕbωꍇɌĂ΂郁\bh̓o^
  def time_now_changed
    @proc_time_now = Proc.new
  end

  #Đ~ɌĂ΂郁\bh̓o^
  def play_stop_changed
    @proc_movie1 = Proc.new
  end

  #ʐMXbhJn
  def start
    @thread = Thread.new{
      begin
	@socket = TCPSocket.open(@host, 1048)
	while true

	  STDOUT << "-" * 40 + "\n" if $DEBUG
	  @socket.write(ConnectionCommand)

	  #܂TCY󂯎
	  head_size = @socket.read(2)
	  size = head_size.unpack("n")[0]
	  #TCYɍ킹ăX|X擾
	  response = @socket.read(size - 2)
	  parse(response)
	  if $DEBUG
	    STDOUT.flush
	    STDERR.flush
	  end

	end
      #rescue
#	#G[̏
#	STDERR << $!
#	STDERR << $!.backtrace
#	exit(-1)
      ensure
	#Ƃ̓\Pbg
	@socket.close
      end
    }
  end

  #--
  #------------------------------------------------------- Private
  #++

  private

  #ԓ͂
  def parse(response)
    command = response[2, 4].unpack("N")[0]
    cmd_bitary = response[2, 4].unpack("B*")[0].split("").reverse
    @arg_idx = 6
    cmd_no = 0

    #fobO\
    if $DEBUG
      view_array(response.unpack("C*"))
      print "01234567890123456789012345678912\n"
      print cmd_bitary.join("") + "\n"
    end


    cmd_bitary.each do |bit|
      if bit == "1"

	begin
	  case cmd_no
	  when 0
	    #HDD/DVD
	    # DVD=0 HDD=1
	    @hdddvd = get_next_i(response)
	    printf("hdddvd:%d\n", @hdddvd) if $DEBUG


	  when 1
	    # unknown
	    unknown = get_next_i(response)

	  when 2
	    #Đ=2 Đ~=0
	    @movie1 = get_next_i(response)
	    printf("movie1:%d\n", @movie1) if $DEBUG

	    #\bho^ĂꍇĂяo
	    if @proc_movie1
	      @proc_movie1.call(@movie1)
	    end
	    
	  when 3
	    # unknown
	    unknown = get_next_i(response)

	  when 4
	    # ĐԁH
	    # [ ]=3 [>]=4 [<]=7 [||]=5 [>>]=6
	    @movie2 = get_next_i(response)
	    printf("movie2:%d\n", @movie2) if $DEBUG

	  when 5
	    # unknown
	    unknown = get_next_i(response)

	  when 6
	    #change status
	    @status = get_next_i(response)
	    printf("status:%d\n", @status) if $DEBUG

	  when 7
	    #channel change
	    @channel = get_next_i(response)
	    printf("channel:%d\n", @channel) if $DEBUG

	  when 8 .. 9
	    #unknown
	    unknown = get_next_i(response)
	    
	  when 10
	    #time1
	    @time_now = get_next_i(response)
	    printf("time1: %s\n", time_to_s(@time_now)) if $DEBUG

	    #\bho^ĂꍇĂяo
	    if @proc_time_now
	      @proc_time_now.call(@time_now)
	    end

	  when 11
	    #time2
	    @time_now2 = get_next_i(response)
	    printf("time2: %s\n", time_to_s(@time_now2)) if $DEBUG
	    
	  when 12
	    #change title no
	    @no = get_next_i(response)
	    printf("no:%d\n", @no) if $DEBUG

	  when 13
	    #title and chapter
	    @title = get_next_string(response)
	    @chapter = get_next_i(response)
	    printf("[%s] c:%d\n", @title, @chapter) if $DEBUG
	    
	    #i]̋󔒕i߂
	    unknown = get_next_string(response)

	    #\bho^ĂꍇĂяo
	    if @proc_title
	      @proc_title.call(@title)
	    end

	  when 14
	    #netkeyboard input
	    #1̂Ƃon 0̂Ƃoff
	    @netkeyboard = get_next_i(response)
	    @netkeystring = get_next_string(response)
	    printf("netkeyboard:%d [%s]\n", @netkeyboard, @netkeystring) if $DEBUG

	    #\bho^ĂꍇĂяo
	    if @proc_netkeyboard
	      @proc_netkeyboard.call(@netkeyboard, @netkeystring)
	    end

	  when 15
	    #totaltime
	    @time_tortal = get_next_i(response)
	    printf("totaltime: %s\n", time_to_s(@time_tortal)) if $DEBUG

	    #\bho^ĂꍇĂяo
	    if @proc_time_tortal
	      @proc_time_tortal.call(@time_tortal)
	    end

	  when 16
	    #R1/R2
	    @r1r2 = get_next_i(response)
	    printf("r1r2:%d\n", @r1r2) if $DEBUG
	    
	    #17 lineinςƂon
	    #28 ^3003ƂH
	    
	  end #end of case

	rescue
	  #G[NꍇA
	  STDERR << $!
	  STDERR.flush
	  break
	end
      end
      cmd_no += 1
    end
  end

  #𐔒lŎ󂯎
  def get_next_i(response)
    out = response[@arg_idx, 4]
    if out != nil
      @arg_idx += 4
      return out.unpack("N")[0]
    else
      raise "error over"
    end
  end

  #𕶎Ŏ󂯎
  def get_next_string(response)
    out = [response[@arg_idx, 64]]

    if out[0] != nil
      @arg_idx += 64
      return out.pack("Z*").gsub("\000", "")
    else
      raise "OverError"
    end
  end

#if response.length < @arg_idx + 4
	#  STDERR << format("response:%d @arg:%d\n", 
		#	   response.length, @arg_idx.size)
	 # STDERR.flush
	 # break
	#else

  #b/̕ɕϊ
  def time_to_s(time)
    #return time.to_s
    return Time.at(time + 15 * 60 * 60).strftime("%X")
  end
  
  #fobO\p
  def view_array(ary)
    idx = 0
    buf = ""
    while true
      line = format("%4d: ", idx)
      0.upto(9) do |x|
	line += format("%3d ", ary[idx])
	idx += 1
	if ary.size <= idx
	  break
	end
      end
      buf << line + "\n"
      if ary.size <= idx
	break
      end
    end

    if @prev != nil
      if @prev.size == ary.size
	buf << "diff:"
	0.upto(ary.size - 1) do |idx|
	  if @prev[idx] != ary[idx]
	    buf << idx.to_s + " "
	  end
	end
	buf << "\n"
      end
    end

    print buf
    @prev = ary
  end
  
end

#test main ------------------------

if __FILE__ == $0
  rdremo = RDremoconConnector.new("rd-x5")
  #lbgL[{[hCxg̃eXg
  rdremo.netkeyboard_changed{|status, str|
    printf("proc %d %s\n", status, str)
  }
  rdremo.start
  #[v
  while true
    sleep(1)
  end
end
