#ruby -Ks
=begin rdoc
RDlbgRruby
RD-X5/RD-X6𑀍삷GUI

Author:: ghiaccio@plala.to
=end

require 'vr/vruby'
require 'vr/vrdialog'
require 'vr/vrhandler'
require 'vr/vrtooltip'
require 'vr/contrib/vrctlcolor'

require 'vr/clipboard'
require 'vr/vrclipboard'

require '_frm_winrdremo_s.rb'
require "../rdstyle"
require "rdremocon"
require "csv"

#Exerb̎st@C̃pX擾̂߂̋@\
class Win32API
  GetModuleFileName = Win32API.new("kernel32","GetModuleFileName","IPI","I")
  def self.get_exepath
    buf="\0"*260
    len = GetModuleFileName.call(0,buf,buf.length)   # Win32APǏĂяo
    return buf[0,len].tr('\\',"/")                   # pX؂蕶̒u
  end
end

#pX[h_CAO
#  pX[h͂邽߂̃_CAO
class PasswordDialog < VRModelessDialog 

  def _form_init
    self.caption = 'password'
    self.move(213,124,236,192)
    addControl(VRCheckbox,'checkBox1',"pX[hۑ",16,80,192,24,1342242819)
    addControl(VRStatic,'static2',"pX[h",8,48,96,24,1342177280)
    addControl(VRButton,'button1',"M",16,112,72,24,1342242816)
    addControl(VRStatic,'static1',"[U[",8,24,80,24,1342177280)
    addControl(VRButton,'button2',"LZ",120,112,88,24,1342242816)
    addControl(VREdit,'edit2',"",104,24,120,20,1342242944)
    addControl(VRStatic,'static3',"RD̖O",8,0,96,24,1342177280)
    addControl(VREdit,'edit1',"rd-x5",104,0,120,20,1342242944)
    addControl(VRStatusbar,'statusbar',"MƊJn",0,144,228,20,1342177280)
    addControl(VREdit,'edit3',"",104,48,120,24,1342242976)
  end 

  def construct
    _form_init
    @host = "rd-x5"
    @name = ""
    @password = ""
    @exec = nil
    load_initfile
  end
  
  #init@Cǂݍ
  def load_initfile(filename = "rdstyle.ini")
    if test(?r, filename)
      File.open(filename) do |f|
        @host = f.gets.chomp
        @name = f.gets.chomp
        @password = f.gets.chomp
      end
      set_form()
      @checkBox1.check(true)
    end
  end

  #init@C̕ۑ
  def save_initfile(filename = "rdstyle.ini")
    File.open(filename, "w") do |f|
      f << @host << "\n"
      f << @name << "\n"
      f << @password << "\n"
    end
  end

  def set_form
    @edit1.text= @host
    @edit2.text= @name
    @edit3.text= @password
  end

  def get_form
    @host = @edit1.text
    @name = @edit2.text
    @password = @edit3.text
  end
  
  #擾{^ꂽƂ̏
  def button1_clicked
    if not @exec 
      @exec = true #ANbN΍
      get_form()
      #`FbN{bNXďԂۑ
      if @checkBox1.checked?
        save_initfile
      end
      @statusbar.setTextOf(0, "擾łB΂炭҂..")
      @parent.init_rd(@host, @name, @password)
      close(true)
    end
  end

  #LZ{^ꂽ̏
  def button2_clicked
    close(true)
  end
end 

#CEBhE -------------------------------------------------
module Frm_form1

  include VRCtlColor
  include VRKeyFeasible

  #
  def self_created

    #ACR̕ύX ---------------------
    #exëʒu
    exepath = Win32API.get_exepath()
    if exepath =~ /ruby[0-9]*\.exe/i 
      exepath = File.dirname(__FILE__) + "/winrdremo.exe"
    end

    #sACRύX
    ##exerbō쐬exẽ\[Xq
    if test(?e, exepath)
      extractIconA = Win32API.new('shell32','ExtractIconA','LPI','L')
      myIconData = extractIconA.Call(0, exepath, 0)
      sendMessage(128, 0, myIconData)
    end

    #tmrdremõL[Ήf[^Γǂݍ
    load_tmrdremo()
    
    #GUȈC ---------------------------------------
    #Xe[^Xo[̕
    @statusbar.setparts(2, [self.w - 148, -1])

    #lbgL[{[h̓tH[ ------
    #tH[JXɔ悤
    @edit1.add_parentcall("gotfocus")
    #L[Cxgt
    @edit1.add_parentcall("char")

    #
    @edit1.text = "lbgL[{[h҂󂯒"

    #F
    addCtlColor(@edit1)
    setChildTextColor(@edit1, RGB(0x20, 0x20, 0x20))
    setChildBkColor(@edit1, RGB(0xa0, 0xa0, 0xa0))

    #gbNo[ -----------------
    #}EX\
    @trackBar.add_parentcall("lbuttonup")
    @trackBar.add_parentcall("lbuttondown")
    @trackBar.add_parentcall("mousemove")
    #tH[JXɔ悤
    @trackBar.add_parentcall("gotfocus")

    #L[_E󂯕tݒ
    addHandler(WMsg::WM_KEYDOWN,"keydown",MSGTYPE::ARGINTINT,nil)
    acceptEvents([WMsg::WM_KEYDOWN])
    
    #}EX쎞trueɂȂtO
    @trackBar_mouse = nil

    #c[`bv쐬 -----------------
    @tooltip = createTooltip
    @tooltip.bkColor = RGB(0xff,0xe0,0xe0)
    @tooltip_trackBar = @tooltip.addTool(@trackBar, "00:00:00")
    
    #pX[h_CAON
    dlg = @screen.modelessform(self,nil,PasswordDialog)

  end

  #RD̃RʐM/httpʐMNX
  def init_rd(host, user, password)

    @remo = RDremoconConnector.new(host)
    @rdhttp = RDhttp.new(host, user, password)

    #EBhE^CgɃzXg
    self.caption = format("winRDremo[%s]", host)
    #Xe[^Xo[̏
    set_statusbar(0)
    set_statusbar(1)
    
    #Cxgǉ --------------------------------
    #lbgL[{[h쒆trueɂȂtO
    @netkeyboard = nil

    #lbgL[{[hԂςꍇ
    @remo.netkeyboard_changed{|status, str|
      #̓tH[̐Fς
      if status == 1
	@edit1.text = str
	setChildTextColor(@edit1, RGB(0x0, 0x0, 0x0))
	setChildBkColor(@edit1, RGB(0xff, 0xff, 0xff))
	@netkeyboard = true
	#tH[JXړ
	@edit1.focus

	#݂̃^CgNbv{[hɃRs[
	begin
	  Clipboard.open(self.hWnd) do |cb|
	    cb.setText(@remo.title)
	  end
	rescue
	end

      else
	@edit1.text = "lbgL[{[h҂󂯒"
	setChildTextColor(@edit1, RGB(0x20, 0x20, 0x20))
	setChildBkColor(@edit1, RGB(0xa0, 0xa0, 0xa0))
	@netkeyboard = nil
      end
    }

    #ݎԂύXꍇ
    @remo.time_now_changed{|time|
      set_statusbar(1)
      #쒆łȂꍇAgbNo[ړ
      if not @trackBar_mouse
	@trackBar.position= time
      end
    }

    #vԂςƂ
    @remo.time_tortal_changed{|totaltime|
      #gbNo[CAA
      @trackBar.rangeMax = totaltime
      @trackBar.rangeMin = 0
      @trackBar.position = 0
      @trackBar.pagesize = totaltime / 20
      #Xe[^Xo[XV
      set_statusbar(0)
      set_statusbar(1)
    }

    #ĐԂύXꍇ
    @remo.play_stop_changed{|movie1|
      #Xe[^Xo[XV
      set_statusbar(0)
    }
    
    #R̒ʐMJn
    @remo.start
  end

  #TMRDRemõf[^ǂݍ
  def load_tmrdremo(filename = "TMRDREMO.RDX")
    @key2code = Hash.new
    if test(?r, filename)
      open(filename) do |f|
	while f.gets
	  ary = CSV.parse_line(Kconv.tosjis($_))
	  if ary[2] =~ /^[0-9a-f][0-9a-f]$/i
	    @key2code[ary[1].to_i] = ary[2]
	  end
	end
      end
    end
  end

  #Xe[^Xo[֘A -------------------------------
  def set_statusbar(idx)
    return if @remo == nil
    if idx == 0
      txt = @remo.playing? ? " " : " "
      @statusbar.setTextOf(0, txt + @remo.title)
    else
      @statusbar.setTextOf(1, @remo.time_status)
    end
  end

  #̓tH[֘A ----------------------------------
  #L[{[hCxg
  def edit1_char(ansi, keydata)
    return if ansi != 13
    #sR[h̏ꍇA͏I
    if @netkeyboard
      @netkeyboard = nil
      #M
      @rdhttp.get_netkeyboard(@edit1.text)
      
      #FDF
      setChildTextColor(@edit1, RGB(0x20, 0x20, 0x20))
      setChildBkColor(@edit1, RGB(0xa0, 0xa0, 0xa0))

      #tH[JXeɖ߂
      self.focus
    end
    #BEEP炳Ȃ悤ɂ
    return VRMessageHandler::SKIP_DEFAULTHANDLER
  end

  #LłȂꍇAtH[JXeEBhEɓn(L[p)
  def edit1_gotfocus()
    if not @netkeyboard
      self.focus
    end
  end

  #gbNo[֘A  -------------------------------------------------
  #{^ꂽ̃Cxg
  def trackBar_lbuttondown(shift, x, y)
    @trackBar_mouse = true
  end

  #}EX̃Cxg
  def trackBar_mousemove(shift, x, y)
    if @trackBar_mouse 
      #shiftĂƂ͑Ɉړl𑗐M
      if shift == 5 and not @exec_remocon
	@exec_remocon = true
	@rdhttp.get_timebar(@trackBar.position.to_i)
	@exec_remocon = nil
      end
      #Xe[^Xo[̕ύX
      @tooltip.setTextOf(@tooltip_trackBar, 
	Time.at(@trackBar.position + 15 * 60 * 60).strftime("%X"))
    end
  end

  #}EX{^ꂽƂ̃Cxg
  def trackBar_lbuttonup(shift, x, y)
    #Đ̂Ƃ͈ړ
    if @remo and @remo.playing? 
      @rdhttp.get_timebar(@trackBar.position.to_i)
    end

    @trackBar_mouse = nil
  end

  #tH[JXeEBhEɓn(L[p)
  def trackBar_gotfocus()
    self.focus
  end
  
  #EBhE֘A ----------------------------------------------
  #EBhẼL[Cxg
  def self_keydown(keycode, keydata)
    #o^ĂȂL[̏ꍇI
    return nil if not @key2code[keycode]
    return nil if @exec_remocon

    @exec_remocon = true #stO
    # @statusbar.setTextOf(0, keycode.to_s + " " + @key2code[keycode])
    #RR[h𑗐M
    @rdhttp.get_netremocon(@key2code[keycode])
    @exec_remocon = nil
  end


end

#main -----------------------

VRLocalScreen.start Frm_form1

#end of this program
